% Compute the outer solid normals for all the nodes connected to the
% boundary gcells. The result is
% returned as an array, one normal per row.
function [nrmls,areas]=nodal_normals_areas(fens,bdry_gcells)
    conns =get(bdry_gcells,'conn');
    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
    xyz = gather(geom, (1:length(fens)), 'values', 'noreshape');
    Nder = bfundpar (bdry_gcells, [0, 0]);

    nrmls =0* xyz;
    areas =0* xyz(:,1);
    for j=1:size(conns,1)
        conn = conns(j,:);
        kx = gather(geom, conn, 'values', 'noreshape');
        tangents =kx'*Nder;
        Normal =skewmat(tangents(:,1))*tangents(:,2);
        detJ = norm(Normal);
        for k=1:4
            nrmls(conns(j,k),:) =nrmls(conns(j,k),:)+ Normal';
            areas(conns(j,k)) =areas(conns(j,k))+detJ;
        end
    end
    for j=1:size(nrmls,1)
        nn =norm(nrmls(j,:));
        if (nn~=0)
            nrmls(j,:) =nrmls(j,:)/nn;
        end
    end
end
