% Compute the lumped (diagonal) versions of elementwise matrices of the
% individual gcells. The Hinton, Rock, Zienkiewicz lumping method is used.
%
% function ems = lumped_hrz(self,ems)
%
% Return an array of them so they may be assembled.
%    Call as
%       ems = lumped_hrz(self,ems)
%    where
%       ems=element wise matrices
% 
function ems = lumped_hrz(self,ems)
    mat=get(ems,'mat');
    for j=1:length(mat)% Hinton, Rock, Zienkiewicz lumping
        Me=mat{j};
        em2=sum(sum(Me));
        dem2=sum(diag(Me));
        mat{j} =diag(diag(Me)/dem2*em2);
    end
    ems=set(ems,'mat',mat);
end
