% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    x=reference geometry field
%    u=displacement field
% with optional fields
%    color = color of the text
%
function draw (self, gv, context)
    for i=1:length(self.id)
        conn = self.id(i);
        x = gather(context.x, conn, 'values', 'noreshape'); % coordinates of nodes
        u = gather(context.u, conn, 'values', 'noreshape'); % coordinates of nodes
        draw_text (gv, x+u, num2str(self.id(i)), context);
    end
end
