% Evaluate the surface Jacobian.
%
% function Jac = Jacobian_surface(self, conn, N, J, x)
%   
%   where
%      self=gcellset,
%      conn=connectivity of a single cell in which the Jacobian is to be evaluated
%      N=values of the basis functions, size(N) = [nbfuns,1]
%      J = Jacobian matrix
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
% 
function Jac = Jacobian_surface(self, conn, N, J, x)
    [sdim, ntan] = size(J);
    if     ntan==2 % 2-D gcell
        if sdim==ntan
            Jac = J(1,1)*J(2,2)-J(2,1)*J(1,2);% isdet(J);% Compute the Jacobian
        else
            Jac = norm(skewmat(J(:,1))*J(:,2));
        end
    else
        error('Got an incorrect size of tangents');
    end
end
