% Evaluate the basis function matrix for an 4-node quadrilateral.
%
% function val = bfun(self,param_coords)
%
%   Call as:
%      N = bfun (g, pc)
%   where
%      g=gcell,
%      pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=3.
%
function N = bfun(self,param_coords)
    xi=param_coords(1);
    et=param_coords(2);
    N=[1/256*(xi-1)*(et-1)*(9*xi^2-1)*(9*et^2-1);
    -9/256*(3*xi-1)*(et-1)*(xi^2-1)*(9*et^2-1);
    9/256*(3*xi+1)*(et-1)*(xi^2-1)*(9*et^2-1);
    -1/256*(xi+1)*(et-1)*(9*xi^2-1)*(9*et^2-1);
    -9/256*(xi-1)*(3*et-1)*(9*xi^2-1)*(et^2-1);
    81/256*(3*xi-1)*(3*et-1)*(xi^2-1)*(et^2-1);
    -81/256*(3*xi+1)*(3*et-1)*(xi^2-1)*(et^2-1);
    9/256*(xi+1)*(3*et-1)*(9*xi^2-1)*(et^2-1);
    9/256*(xi-1)*(3*et+1)*(9*xi^2-1)*(et^2-1);
    -81/256*(3*xi-1)*(3*et+1)*(xi^2-1)*(et^2-1);
    81/256*(3*xi+1)*(3*et+1)*(xi^2-1)*(et^2-1);
    -9/256*(xi+1)*(3*et+1)*(9*xi^2-1)*(et^2-1);
    -1/256*(xi-1)*(et+1)*(9*xi^2-1)*(9*et^2-1);
    9/256*(3*xi-1)*(et+1)*(xi^2-1)*(9*et^2-1);
    -9/256*(3*xi+1)*(et+1)*(xi^2-1)*(9*et^2-1);
    1/256*(xi+1)*(et+1)*(9*xi^2-1)*(9*et^2-1)];
end

% x=sym('x','real');
% xi=sym('xi','real');
% et=sym('et','real');
% a=1/3;
% x0 =-1;
% l1 =eval(((x-1)*(x-a)*(x-(-a)))/((x0-1)*(x0-a)*(x0-(-a))));
% x0 =-a;
% l2 =eval(((x-1)*(x-a)*(x-(-1)))/((x0-1)*(x0-a)*(x0-(-1))));
% x0 =+a;
% l3 =eval(((x-1)*(x-(-a))*(x-(-1)))/((x0-1)*(x0-(-a))*(x0-(-1))));
% x0 =+1;
% l4 =eval(((x-a)*(x-(-a))*(x-(-1)))/((x0-a)*(x0-(-a))*(x0-(-1))));
% xis = [subs(l1,'x','xi'),subs(l2,'x','xi'),subs(l3,'x','xi'),subs(l4,'x','xi')];
% ets = [subs(l1,'x','et'),subs(l2,'x','et'),subs(l3,'x','et'),subs(l4,'x','et')];
% xisets=(xis'*ets);
% N=xisets;
% for et=[-1,-a,+a,+1]
%     for xi=[-1,-a,+a,+1]
%         n=double(subs(subs(N,'et',num2str(et)),'xi',num2str(xi)));
%         i=find(n>0.99);
%         disp(['% xi=' num2str(xi) ', et=' num2str(et) ';'])
%         disp(['N(' num2str(i) ')=' char(simple(N(i))) ';'])
%     end
% end
% 
% x=sym('x','real');
% xi=sym('xi','real');
% et=sym('et','real');
% a=1/3;
% x0 =-1;
% l1 =eval(((x-1)*(x-a)*(x-(-a)))/((x0-1)*(x0-a)*(x0-(-a))));
% x0 =-a;
% l2 =eval(((x-1)*(x-a)*(x-(-1)))/((x0-1)*(x0-a)*(x0-(-1))));
% x0 =+a;
% l3 =eval(((x-1)*(x-(-a))*(x-(-1)))/((x0-1)*(x0-(-a))*(x0-(-1))));
% x0 =+1;
% l4 =eval(((x-a)*(x-(-a))*(x-(-1)))/((x0-a)*(x0-(-a))*(x0-(-1))));
% xis = [subs(l1,'x','xi'),subs(l2,'x','xi'),subs(l3,'x','xi'),subs(l4,'x','xi')];
% ets = [subs(l1,'x','et'),subs(l2,'x','et'),subs(l3,'x','et'),subs(l4,'x','et')];
% xisets=(xis'*ets);
% N=xisets;
% for et=[-1,-a,+a,+1]
%     for xi=[-1,-a,+a,+1]
%         n=double(subs(subs(N,'et',num2str(et)),'xi',num2str(xi)));
%         i=find(n>0.99);
% %         disp(['% xi=' num2str(xi) ', et=' num2str(et) ';'])
%         disp(['N(' num2str(i) ',:)=[' char(simple(diff(N(i),'xi'))) ',' char(simple(diff(N(i),'et'))) '];'])
%     end
% end