% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    x=reference geometry field
%    u=displacement field
% with optional fields
%    facecolor = color of the faces, solid
%    colorfield =field with vertex colors
%       only one of the facecolor and colorfield may be supplied
%    shrink = shrink factor
%
function draw (self, gv, context)
    context.faces=[1,5,6,2;2,6,7,3;3,7,8,4;5,9,10,6;6,10,11,7;7,11,12,8;9,13,14,10;10,14,15,11;11,15,16,12];
    context.edges= [1,2,3,4,8,12,16,15,14,13,9,5,1];
    a=1/3;
    node_pc=[-1,-1;-a,-1;a,-1;1,-1;...
        -1,-a;-a,-a;a,-a;1,-a;...
        -1,+a;-a,+a;a,+a;1,+a;...
        -1,+1;-a,+1;a,+1;1,+1;...
        ];
    if isfield(context,'shrink')
        c=ones(size(node_pc,1),1)*(sum(node_pc)/size(node_pc,1));
        pc=c+context.shrink*(node_pc-c);
        for j=1:size(pc,1)
            context.shrunk_pc_N{j}=bfun(self,pc(j,:));
        end
    end
    draw (self.gcellset_2_manifold, gv, context);
end
