% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'bdryconn'}, {'connectivity (node identifiers), array [nfens,4]'}}
            };
        val = cat(1, get(self.gcellset_2_manifold), val);
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case {'edgeconn','bdryconn'}
                conn=get(self.gcellset_2_manifold,'conn');
                val = [conn(:,[1,2,3,4]);conn(:,[4,8,12,16]);conn(:,[16,15,14,13]);conn(:,[13,9,5,1])];
            case {'bdrygcell'}
                val = @gcellset_L4;
            otherwise
                val = get(self.gcellset_2_manifold, prop_name);
        end
    end
end
