% Constructor of the graphic viewer class.
%
% function retobj = graphic_viewer (varargin)
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
% Parameters: 
%    axes= Matlab axes handle (optional). If the 'axes' parameter is not
%    supplied a new figure is created with new axes and those are used by
%    the graphic viewer.
%
function retobj = graphic_viewer (varargin)
    class_name='graphic_viewer';
    if (nargin == 0)
        parent=classbase;
        self.limits=[];
        h=default_figure('visible','off');
        self.axes =gca;
        self = class(self, class_name, parent);
        retobj = self;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters =varargin{1};
            parent=classbase;
            self.axes =0;
            if (isfield(Parameters,'axes' ))
                self.axes =Parameters.axes;
            else
                h=default_figure('visible','off');
                self.axes =gca;
            end
            self.limits=[];
            self = class(self, class_name, parent);
            retobj = self;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
