% graphic_viewer
%   This class provides methods to draw the shape of the 
%   finite element mesh, with optional coloring of some
%   function defined on the mesh, integration point quantities, arrows, etc.
%
%   @graphic_viewer/graphic_viewer - Constructor
%   @graphic_viewer/get - Gets an attribute
% 
%   @graphic_viewer/clear - Clear the axes
%   @graphic_viewer/reset - Reset the axes
%   @graphic_viewer/camget - Get the camera orientation
%   @graphic_viewer/camset - Set the camera orientation
%   @graphic_viewer/camtarget - Set the camera target
%   @graphic_viewer/rotate -  Turn on rotation/zoom/panning controls
%   @graphic_viewer/headlight - Turn on the headlight
% 
%   @graphic_viewer/draw_text - Draw some text
%   @graphic_viewer/draw_cylinder - Draw cylinder
%   @graphic_viewer/draw_ellipsoid - Draw an ellipsoid
%   @graphic_viewer/draw_polygon - Draw a polygon
%   @graphic_viewer/draw_polyline - Draw a polyline
%   @graphic_viewer/draw_arrow - Draw an arrow
% 
%   @graphic_viewer/draw_colorbar - Draw a color bar
%   @graphic_viewer/draw_axes - Draw coordinate axis arrows
%   @graphic_viewer/draw_planes - Draw coordinate planes
%   @graphic_viewer/draw_grid_lines - Draw grid lines
% 
