% property
%   This is a collection of classes implementing various
%   property collections. For instance, the *linel*  classes
%   supply   material moduli for elastic materials. 
% 
% -base class
%   @property/get - Get an attribute
%   @property/set - Set an attribute
%   @property/property - Constructor
% 
% -heat diffusion properties
%   @property_diffusion/property_diffusion - Constructor.
%   @property_diffusion/get - Get an attribute
% 
% -thermal (heat) diffusion properties
%   @property_thermal_diffusion/property_thermal_diffusion - Constructor.
%   @property_thermal_diffusion/get - Get an attribute
% 
% -electrostatics properties
%   @property_electrostatics/property_electrostatics - Constructor.
%   @property_electrostatics/get - Get an attribute
% 
% -linear elastic anisotropic homogeneous material properties
%   @property_linel_aniso/property_linel_aniso - Constructor
%   @property_linel_aniso/get - Get an attribute
% 
% -linear elastic isotropic homogeneous mechanical properties
%   @property_linel_iso/property_linel_iso - Constructor
%   @property_linel_iso/get - Get an attribute
% 
% -linear elastic isotropic inhomogeneous mechanical properties
%   @property_linel_iso_inhomog/property_linel_iso_inhomog - Constructor
%   @property_linel_iso_inhomog/get - Get an attribute
% 
% -linear elastic transversely isotropic homogeneous mechanical properties
%   @property_linel_transv_iso/property_linel_transv_iso - Constructor
%   @property_linel_transv_iso/get - Got an attribute
% 
% -linear elastic orthotropic mechanical properties
%   @property_linel_ortho/property_linel_ortho - Constructor
%   @property_linel_ortho/get - Get an attribute
% 
% -viscous fluid mechanical properties
%   @property_viscous_fluid/property_viscous_fluid - Constructor
%   @property_viscous_fluid/get - Get an attribute
% 


