% Implicit mid-point integrator described as IMID  in the paper on the
% dynamic equivalence of implicit integrators. This integrator is
% equivalent to that trapezoidal rule TRAP constructor.
%   Call as:
%     ri = rotint_dyneq_imid
%
function retobj = rotint_dyneq_imid (varargin)
    class_name='rotint_dyneq_imid';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end

