% Constructor for momentum and energy conserving integrator from Simo, Wong.
%   Call as:
%     ri = rotint_simo_wong_algo_c1
% The momentum and energy conserving integrator from Simo, Wong.
%
function retobj = rotint_simo_wong_algo_c1 (varargin)
    class_name='rotint_simo_wong_algo_c1';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        self.Alpha = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            self.Alpha = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end



