% Assemble a cell array of element matrices.
%
% function retobj = assemble (self, ems)
%
% Assemble a cell array of element matrices, that is object of type elemat,
% into a dense matrix.
%
function retobj = assemble (self, ems)
    invalid_eqnum = get(self.sysmat, 'invalid_eqnum');
    [neqns,neqns] = size(self.mat);
    for m = 1:length(ems)
        if placesymm(ems(m))
            eqnums = get(ems(m), 'eqnums');
            mat    = get(ems(m), 'mat');
            for j=1:length(mat)
                emask=eqnums{j}>invalid_eqnum;
                valid_eqnums=eqnums{j}(emask);
                rmat=mat{j}(emask,emask);
                nve=length(valid_eqnums);
                for r=1:nve
                    for c=1:nve
                        self.mat(valid_eqnums(r),valid_eqnums(c)) = self.mat(valid_eqnums(r),valid_eqnums(c)) + rmat(r,c);
                    end
                end
            end
        else
            eqnums_row = get(ems(m), 'eqnums_row');
            eqnums_col = get(ems(m), 'eqnums_col');
            mat    = get(ems(m), 'mat');
            for j=1:length(mat)
                emaskr=eqnums_row{j}>invalid_eqnum;
                emaskc=eqnums_col{j}>invalid_eqnum;
                valid_eqnums_row=eqnums_row{j}(emaskr);
                valid_eqnums_col=eqnums_col{j}(emaskc);
                rmat=mat{j}(emaskr,emaskc);
                nver=length(valid_eqnums_row);
                nver=length(valid_eqnums_row);
                for r=1:nver
                    for c=1:nvec
                        self.mat(valid_eqnums_row(r),valid_eqnums_col(c)) = self.mat(valid_eqnums_row(r),valid_eqnums_col(c)) + rmat(r,c);
                    end
                end
            end
        end
    end
    retobj = self;
end