
% Initialization
umid = u+(dt/2)*v; % guess
du = 0*u; % this will hold displacement increment
umid = apply_ebc(umid);
du = apply_ebc(du);
F0 = start (sysvec, get(u, 'neqns'));
F0 = assemble (F0, inertial_force(feb, geom, u+(dt/2)*v, Mems));

iter=1;
while 1
    feb1=feb;
    F = F0;
    [febc,evsc] = restoring_force(febc,geom,umid,u);       % Internal forces
    [feba,evsa] = restoring_force(feba,geom,umid,u);
    evs=cat(2,evsc,evsa);
    F = assemble (F, evs);
    [febstab,evsc] = restoring_force_stab(febc,geom,umid,u,eltyd(eix).stabfact);       % Internal forces
    [febstab,evsa] = restoring_force_stab(feba,geom,umid,u,eltyd(eix).stabfact);
    evs=cat(2,evsc,evsa);
    F = assemble (F, evs);
    F = assemble (F, inertial_force(feb, geom, (-1)*umid, Mems));

    ems=cat(2,stiffness(febc, geom, umid,u),stiffness(feba, geom, umid,u),...
        stiffness_geo(febc, geom, umid,u),stiffness_geo(feba, geom, umid,u),...
        stiffness_stab(febc, geom, umid,u,eltyd(eix).stabfact),stiffness_stab(feba, geom, umid,u,eltyd(eix).stabfact), ...
        Mems);
    K =assemble (K,ems);
    K = external_decomposition (K,  []);
    du = scatter_sysvec(du, K\F); % Displacement increment
    %                 max(abs(get(F,'vec')))
    umid = umid + du;   % increment displacement
    K = reinitialize (K);
    %                     if graphics,
    %                         draw(feb,gv, struct ('x', geom,'u',umid, 'facecolor','none'));
    %                         camset (gv,cam); pause(0.5); cam =camget(gv);
    %                         drawnow
    %                     end
    Report(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
    if (max(abs(gather(du,[],'values'))) < utol) break; end;% convergence check
    if (iter >maxit)% bailout for failed convergence
        error( [' Possible failed convergence']);
    end
    iter=iter+1;
end
F = start (sysvec, get(u, 'neqns'));
[febc,evsc] = restoring_force(febc,geom,umid,u);       % Internal forces
[feba,evsa] = restoring_force(feba,geom,umid,u);
F = assemble (F, cat(2,evsc,evsa));
[febstab,evsc] = restoring_force_stab(febc,geom,umid,u,eltyd(eix).stabfact);       % Internal forces
[febstab,evsa] = restoring_force_stab(feba,geom,umid,u,eltyd(eix).stabfact);
F = assemble (F, cat(2,evsc,evsa));
amid=scatter_sysvec(0*du, M\F);
vmid=v + (dt/2)*amid;
E = defor_energy(febc,geom,umid,u)+defor_energy(feba,geom,umid,u);   Es=[Es,E];
Vv=gather_sysvec(vmid);
MVv =get(assemble (start (sysvec, get(u,'neqns')),inertial_force(feb, geom, vmid, Mems)),'vec');
Kin =(Vv'*MVv)/2;
Kin = Kin*(1/4*dt^2); Ks=[Ks,Kin];
Energy =Es + Ks;
plot(Energy); hold on
plot(Es,'r-')
plot(Ks,'g-')
drawnow

v1=v +dt*amid;
u1 =u+dt*v+(dt^2/2)*amid;
u = u1;       % update + the displacement
v = v1;       % update the displacement

