disp('Plane strain Beam from Hughes 1987, page 219ff');

% Parameters:
E=1;
nu=0.3;
nu=0.499999999;
P=1;
L=16;
c=2;
% smult=150;
smult=40;
E1=E/(1-nu^2); nu1=nu/(1-nu); I=(2*c)^3/12;
uexx=@(x,y)(P/(6*E1*I)/2*(-y).*(3*(L^2-(L-x).^2)+(2+nu1)*(y.^2-c^2)));
uexy=@(x,y)(P/(6*E1*I)/2*(((L-x).^3-L^3)-((4+5*nu1)*c^2+3*L^2)*(L-x-L)+3*nu1*(L-x).*y.^2));
graphics = ~true;
options.other_dimension = 1;

% Choose the type
% Meshf=@block2d;
% integration_rule = gauss_rule(2,2);
% febf =@feblock_defor_ss;
% Style ='ro-';
Meshf=@block2d;
integration_rule = tensprod_nq_rule(2);
febf =@feblock_defor_ss_nicer;
Style ='rx-';
Meshf=@block2d;
integration_rule = tensprod_nq_rule(2);
febf =@feblock_defor_ss_nice;
Style ='b*-';
% Meshf=@block2d_refined_w_t3; 
% integration_rule = [];
% febf =@feblock_defor_ss_nicermix;
% Style ='c*-';
Meshf=@t3block2d;
integration_rule = simplex_nq_rule (2);
febf =@feblock_defor_ss_nice;
Style ='cv-';
% Meshf=@block2d;
% integration_rule = gauss_rule(2, [1 2]);
% febf =@feblock_defor_ss_sri;
% Style ='gs-';

ns=4:4:32;
ns=4:4:12;
% ns=1;
errs = [];

for n=ns
    options.to_refine= 11:7:(4*n^2-1);
    [fens,gcells] = Meshf(L,2*c,2*n,2*n, options);
    rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
    dxy=min(L,c)/n/100;
    sxy=smult*dxy;
    xy=get(fens,'xyz');
    for i=1:length(fens)
        xy(i,2)=xy(i,2)-c;
        if (xy(i,1)>dxy) & (xy(i,2)>dxy-c) & (xy(i,1)<L-dxy) & (xy(i,2)<c-dxy)
            xy(i,:)=[xy(i,1)+(2*rand(1)-1)/2*sxy,xy(i,2)+(2*rand(1)-1)/2*sxy];
        end
    end
    fens=set(fens,'xyz',xy);
%      mesh{1}=fens;
%             mesh{2}=gcells;
%             drawmesh(mesh); view(2); pause (1)
    % Material
    propm = property_linel_iso(struct('E',E,'nu', nu));
    mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
    % Finite element block
    feb = febf (struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero out
    % Apply EBC's    
    ebc_fenids=fenode_select (fens,struct('box',[0 0 0 0],'inflate', 0.0001));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=[];
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    ebc_fenids=fenode_select (fens,struct('box',[0 0 c c],'inflate', 0.0001));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+1;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    ebc_fenids=fenode_select (fens,struct('box',[0 0 -c -c],'inflate', 0.0001));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+1;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);

    % Number equations
    u   = numbereqns (u);
    % Assemble the system matrix
    ems = stiffness(feb, geom, u);
    K = sparse_sysmat;
    K = start (K, get(u, 'neqns'));
    K = assemble (K, ems);
    K = finish (K);
    % Load
    I=2/3*c^3;
    nl=fenode_select (fens,struct ('box',[L L -c c],'inflate',0.0001));
    F = start (sysvec, get(u, 'neqns'));
    xy=get(fens,'xyz');
    for i=1:length(nl)
        X=xy(nl(i),:);
        magn=P/2/I*(c^2-X(2)^2)/n;
        F = assemble (F, loads(nodal_load(struct('id',nl(i),'dir',2,'magn',magn)), u));
    end
    nl=fenode_select (fens,struct ('box',[0 0 -c c],'inflate',0.0001));
    for i=1:length(nl)
        X=xy(nl(i),:);
        magn=-P/2/I*(c^2-X(2)^2)/n;
        F = assemble (F, loads(nodal_load(struct('id',nl(i),'dir',2,'magn',magn)), u));
    end
    nl=fenode_select (fens,struct ('box',[0 0 -c c],'inflate',0.0001));
    for i=1:length(nl)
        X=xy(nl(i),:);
        magn=P*L/I*X(2)/n;
        F = assemble (F, loads(nodal_load(struct('id',nl(i),'dir',1,'magn',magn)), u));
    end
    F = finish(F);
    % Solve
    u = scatter_sysvec(u, get(K,'mat')\get(F,'vec'));
    % get(u,'values')
sum(get(F,'vec'))

    midpt=fenode_select (fens,struct ('box',[L L 0 0],'inflate',0.0001));
    midpt_c=gather(geom, midpt, 'values');
    midpt_u=gather (u, midpt, 'values');
%     ucex=P/6/E*(1-nu^2)/2/I*((4+5*nu/(1-nu))*(2*c)^2*L/4+2*L^3);
    ucex=uexy(L,0);
    disp ([' normalized displacement =' num2str(midpt_u(2)/ucex)]);
    % Relative error
    errs(end+1) = abs(ucex-midpt_u(2))/abs(ucex);

    if (graphics)
        % Plot
        gv=graphic_viewer;
        gv=reset (gv,[]);
        scale=0.1;
        draw(feb,gv, struct ('x', geom, 'u', 0*u, 'facecolor','none'));
        draw(feb,gv, struct ('x', geom, 'u', +scale*u,'facecolor','red'));
        xlabel('X');
        ylabel('Y');
        zlabel('Z');
        view (2)
        % hold on
    end
end
set(gca, 'FontSize', 20);
loglog(1./ns, abs(errs), Style, 'MarkerSize', 8, 'LineWidth', 2);
xlabel('Mesh density');
ylabel('Relative error');
hold on
figure(gcf)

% view (2)