% Thick-walled cylinder (MacNeal, Harder standard test)
Omegatol=sqrt(10000*eps);
% Parameters:
E=1000;
nu=0.24;
uzex= 5.0399e-3;
% nu=0.49;
% uzex= 5.0399e-3;
% % nu=0.499;
% % uzex= 5.0602e-3;
% nu=0.4999;
% uzex= 5.0623e-3;
R= 6;
t=6;
L=t;
ang=35/180*pi;
p=  1;
randshiftmult= 0.37;
randshiftmult= 0.;
parshiftmult= 0.5;
parshiftmult= 0.;
graphics = true;
scale=200;

mix = 1;
clear mesd
mesd(mix).ref=[1:4];
mesd(mix).ny=1;
mesd(mix).nc=1;
mesd(mix).nt=1;
mix = mix+1;

eix=1;
clear eltyd

% eltyd(eix).label ='T10';
% eltyd(eix).mf =@t4blockT10;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=tet_rule (4);
% eltyd(eix).surface_integration_rule=tri_rule(3);
% eltyd(eix).styl='kv--';
% eix=eix+1;


eltyd(eix).label ='NICE-T4';
eltyd(eix).mf =@t4block;
eltyd(eix).blf =@feblock_defor_ss_nice;
eltyd(eix).integration_rule= simplex_nq_rule (3);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='m^-';
eix=eix+1;

eltyd(eix).label ='NICE-H8';
eltyd(eix).mf =@block;
eltyd(eix).blf =@feblock_defor_ss_nice;
eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
eltyd(eix).styl='md-';
eix=eix+1;


eltyd(eix).label ='H27';
eltyd(eix).mf =@blockH27;
eltyd(eix).blf =@feblock_defor_ss;
eltyd(eix).integration_rule=gauss_rule (3,3);
eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
eltyd(eix).styl='ks-';
eix=eix+1;

eltyd(eix).label ='NICE-H27';
eltyd(eix).mf =@blockH27;
eltyd(eix).blf =@feblock_defor_ss_nice;
eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
eltyd(eix).styl='mh-';
eix=eix+1;

eltyd(eix).label ='H20R';
eltyd(eix).mf =@blockH20;
eltyd(eix).blf =@feblock_defor_ss;
eltyd(eix).integration_rule=gauss_rule (3,2);
eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
eltyd(eix).styl='ro-';
eix=eix+1;

eltyd(eix).label ='NICE-H20';
eltyd(eix).mf =@blockH20;
eltyd(eix).blf =@feblock_defor_ss_nice;
eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
eltyd(eix).styl='mo--';
eix=eix+1;

eltyd(eix).label ='H20';
eltyd(eix).mf =@blockH20;
eltyd(eix).blf =@feblock_defor_ss;
eltyd(eix).integration_rule=gauss_rule (3,3);
eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
eltyd(eix).styl='k>--';
eix=eix+1;

for eix = 1:length(eltyd)
         disp(eltyd(eix).label);
   h=[];
    alpha=[];
    rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');

    for mix = 1:length(mesd)
        ns=[];
        uzs=[];
        neqns = [];

        for     ref=mesd(mix).ref;
                    %% Create the mesh and initialize the geometry
                    [fens,gcells]= feval (eltyd(eix).mf, ang, L/2,t,mesd(mix).nc*ref,mesd(mix).ny*ref,mesd(mix).nt*ref);
                    internal_fenids=fenode_select(fens,struct('box',[0 ang 0 L/2 0 0],'inflate',t/10000));
                    bdry_gcells = mesh_bdry(gcells, struct('other_dimension',1.0));
                    bcl = gcell_select(fens, bdry_gcells, ...
                        struct ('box',[0 ang 0 L/2 0 0],'inflate',t/10000));
                    if randshiftmult~=0
                        fens = block_random_shift(fens, randshiftmult*[ang/(nc)/3,0,t/(nt*ref)/3],  struct('link', [0, 1, 0]));
                    end
                    if parshiftmult~=0
                        options.displacement=cell(3);
                        ax=parshiftmult*ang/(nc)*2/ref;
                        options.displacement{1} =...
                            @(xyz)(ax*sin(pi*xyz(:,3)/(2*t/(nt*ref))));
                        options.displacement{2} =@(xyz)(0*xyz(:,3));
                        options.displacement{3} =@(xyz)(0*xyz(:,3));
                        fens = block_function_shift(fens, options);
                        %                         mesh{1}=fens;
                        %                         mesh{2}=gcells;
                        %                         drawmesh(mesh); view(3); pause%(1)
                    end
                    for i=1:length (fens)
                        xy=get (fens(i),'xyz');
                        a=xy(1); y=xy(2); r=R-t/2+xy(3);
                        xy=[r*sin(a) y (r*cos(a))];
                        fens(i)=set(fens(i),'xyz', xy);
                        %                         get(fens(i),'id'),get(fens(i),'xyz')
                    end
                    
%                     mesh{1}=fens;
%                     mesh{2}=gcells;
%                     drawmesh(mesh); view(3); pause%(1)
                    
                    prop = property_linel_iso (struct('E',E,'nu',nu));
                    mater = mater_defor_ss_linel_triax (struct('property',prop));

                    feb = feval (eltyd(eix).blf, struct ('mater',mater,...
                        'gcells',gcells, 'integration_rule',eltyd(eix).integration_rule));
                    % ,'stabfact',0.1));
                    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));

                    %% Define the displacement field, and zero it out
                    u   = 0*geom;

                    %% Apply the EBC''s
                    nl=fenode_select (fens,struct ('box',[0 0 0 L/2 -100*R 100*R],'inflate',t/10000));
                    u = set_ebc(u, nl, nl*0+1, nl*0+1, nl*0);
                    u = apply_ebc (u);
                    nl=fenode_select (fens,struct ('box',[-100*R 100*R 0 0 -100*R 100*R],'inflate',t/10000));
                    u = set_ebc(u, nl, nl*0+1, nl*0+2, nl*0);
                    u = apply_ebc (u);
                    nl=fenode_select (fens,struct ('box',[-100*R 100*R L/2 L/2 -100*R 100*R],'inflate',t/10000));
                    u = set_ebc(u, nl, nl*0+1, nl*0+2, nl*0);
                    u = apply_ebc (u);
                    nl=fenode_select (fens,struct ('box',[-100*R 100*R 0 L/2 0 0],'inflate',t/10000));
                    u = set_ebc(u, nl, nl*0+1, nl*0+3, nl*0);
                    u = apply_ebc (u);

                    %% Number the equations
                    u   = numbereqns (u);

                    Gh = start (sparse_separow_sysmat, get(u, 'neqns'));
                    Gh = assemble (Gh, infsup_Gh(feb, geom, u));
                    Ghm =full (get(Gh,'mat'));
                    Sh = start (sparse_separow_sysmat, get(u, 'neqns'));
                    Sh = assemble (Sh, infsup_Sh(feb, geom, u));
                    Shm=full (get(Sh,'mat'));
                    [modes,Omega]=eig(Ghm,Shm);
                    absOmega =diag(Omega);
                    ix=find(absOmega<0);
                    absOmega(ix)=0;
                    absOmega =sqrt(sort(absOmega))';
%                     loglog(absOmega,eltyd(eix).styl); hold on; pause(1);
                    ix=find(absOmega>Omegatol);
                    %         rank(Shm)-rank(Ghm)
                    %         ix(1)
                    alpha=[alpha,absOmega(ix(1))]
                    h=[h,1/(length(fens))^(1/3)];
        end
    end
        loglog(h,alpha,eltyd(eix).styl); hold on
        figure(gcf)
    
end
