% Choose:
Derivative=[]; %to plot the function surface; choose
% Derivative=[1]; %to plot the derivative wrt x
% Derivative=[2]; % or this to plot derivative wrt y
% Function with derivatives: exact expressions
zexpr='z=(0.5 *x.^2.*y -x.*y.^2)/10;';
zxexpr='z=(2*0.5 *x.^1.*y -y.^2)/10;';
zyexpr='z=(0.5 *x.^2 -2*x.*y.^1)/10;';

[fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
    'curve 1  line   0 0 8 0',...
    'curve 2  line   8 0 8 6 ',...
    'curve 3  line   8 6 0 6',...
    'curve 4  line   0 6 0 0',...
    'subregion 1  property 1 boundary 1 2 3 4',...
    ['m-ctl-point constant ' num2str(0.85)]
    }, 1.0);
% drawmesh({fens,gcells},'gcells','nodes','shrink', 0.89);
% view(2)
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
xy=get(geom,'values'); x=xy(:,1); y=xy(:,2);


eval([zexpr]);
geom3 = field(struct ('name', ['geom3'],  'data',[x,y,z]));
gv=graphic_viewer;
gv=reset (gv,[]);
conns = get(gcells, 'conn'); % connectivity
for i=1:count (gcells)
    conn=conns(i,:);
    if (~isempty( Derivative))
        x = gather(geom, conn, 'values', 'noreshape'); % coord
        Nder = bfundpar (gcells,  [0, 0]);
        Ndersp=bfundsp(gcells,Nder,x);
        xyz=get(geom3,'values');
        xyz(conn, 3) =Ndersp(:,Derivative)'*xyz(conn, 3);
        geom3x = field(struct ('name', ['geom3x'],  'data',xyz));
        draw(subset(gcells,i), gv, struct ('x',geom3x, 'u',0*geom3x,...
            'facecolor','red','edgecolor','red', 'shrink',1));
        draw(subset(gcells,i), gv, struct ('x',geom, 'u',0*geom, ...
            'facecolor','none'));
    else
        draw(subset(gcells,i), gv, struct ('x',geom3, 'u',0*geom3,...
            'facecolor','red','edgecolor','red', 'shrink',1));
        draw(subset(gcells,i), gv, struct ('x',geom, 'u',0*geom, ...
            'facecolor','none'));
    end
end
lightangle(135,15)
% set(gcf,'Renderer','zbuffer')
set(findobj(gca,'type','surface'),...
    'FaceLighting','flat',...
    'AmbientStrength',.6,...
    'SpecularStrength',.9,'SpecularExponent',25,...
    'BackFaceLighting','lit')

[fens,gcells] =T3_block (8, 6, 60, 40, []);
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
xy=get(geom,'values'); x=xy(:,1); y=xy(:,2);
if (~isempty( Derivative))
    if (Derivative==1)
        eval([zxexpr]);
    else
        eval([zyexpr]);
    end
else
    eval([zexpr]);
end
geom3 = field(struct ('name', ['geom3'],  'data',[x,y, z]));
% % gv=graphic_viewer;
% % gv=reset (gv,[]);
draw(gcells, gv, struct ('x',geom3, 'u',0*geom3,...
        'facecolor','yellow','edgecolor','none', 'shrink',1));
cameratoolbar
lightangle(135,15)
% set(gcf,'Renderer','zbuffer')
set(findobj(gca,'type','surface'),...
    'FaceLighting','flat',...
    'AmbientStrength',.6,'DiffuseStrength',.8,...
    'SpecularStrength',.9,'SpecularExponent',25,...
    'BackFaceLighting','lit')