disp(' ');
disp('Spinning RB: McLachlan, Zanna (2003)');
% Create the mesh and initialize the geometry
cd(sofea_work_path);
[fens,gcells] = mesh_hexahedron([-1, -4, -18; 1, 4, 18],1, 1, 1);
feb = feblock(struct('gcells',gcells));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
u = 0*geom;
graphics= ~true;
tend=100;
nmarkers=10;
% clf;
dts=[4];
dts=[1 1/2 1/4 1/64];
dts=[1,0.5];
 exact_spm=rand(3, 1);
 for zeta = [0.5,0.382 ]
    nRs=[]; 
    nmbfs=[];
    nmsps=[];
    marker_type='oxd*sdv^<>ph'; marker_type=[marker_type marker_type];
    setnum=0;
    for plotwhat={'Pi'}
        % for plotwhat={'0'}
        for rin={'dyneq_trapm_zeta' }
            %     for rin={'dyneq_trap' 'dyneq_trapm' 'dyneq_imid' 'dyneq_imidm'}
            ri=eval(['rotint_' rin{1}]);
            nRs=[];
            nmbfs=[];
            nmsps=[];
            for dt=dts;
                % Data, Initial conditions
                torque = inline('[0;0;0]','t', 'R');
                % Data, Initial conditions
                %I=diag([0.9218 0.7382 0.1762]);
                I=diag([0.7382+0.1762 0.9218+0.1762 0.9218+0.7382]);
                R = rotmat([0 0 0]);
%                 exact_spm=[0.4165 0.9072 0.0577]';
                exact_spm=exact_spm/norm(exact_spm);
                omega = R*I\exact_spm;
                converged_R_at_100 = [
                    0.93945744938600  -0.11984043402503  -0.32102643374938
                    0.28502825877012   0.79331904578114   0.53796262258950
                    0.19020670991221  -0.59689459871370   0.77944739753930     ];
                converged_Omega_at_100 = [
                    0.72276710244953
                    0.57869213361434
                    0.24056842553917
                    ];
                line='-';
                % Choose integrator
                ri = set(ri, 'I', I);
                ri = set(ri, 'R', R);
                ri = set(ri, 'omega', omega);

                colors=['r'; 'g'; 'b'; 'k'];
                limits=1.1*[-18, 18, -18, 18, -18, 18];
                nsteps=round(tend/dt);
                reportat=nsteps/2;

                omegas=zeros(3,nsteps+1);
                momenta=zeros(3,nsteps+1);
                kinenergy=zeros(1,nsteps+1);
                etas=zeros(1,nsteps+1);
                Omegas=zeros(3,nsteps+1);
                vectup=zeros(3,nsteps+1);
                incrrotvect=zeros(3,nsteps+1);
                rotvect=zeros(3,nsteps+1);
                incrrotvectmag=zeros(1,nsteps+1);
                if graphics
                    gv=graphic_viewer;
                    gv=reset (gv,struct('limits',limits));
                    draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                    headlight(gv);
                end
                tic;
                ri = set(ri, 't', 0);
                ri = set(ri, 'zeta', zeta);
                % store history for t=0
                snapshot=1;
                omega=get(ri, 'omega');
                R1=R;
                R=get(ri, 'R');
                V=rotmat2rotvec((R1')*R);
                incrrotvect(:,snapshot)=V;
                incrrotvectmag(:,snapshot)=norm(V)*180/pi;
                rotvect(:,snapshot)=rotmat2rotvec(R);
                omegas(:,snapshot)=omega;
                Omegas(:,snapshot)=R'*omega;
                L=R*I*R'*omega;
                momenta(:,snapshot)=L;
                kinenergy(snapshot)= 1/2*omega'*L;
                etas(snapshot)=get(ri,'eta');
                vectup(:,snapshot)=R(:,3);
                for i=1:nsteps
                    % advance by one step
                    ri = advance(ri, torque,dt,1);
                    % save history
                    snapshot=snapshot+1;
                    omega=get(ri, 'omega');
                    R1=R;
                    R=get(ri, 'R');
                    V=rotmat2rotvec((R1')*R);
                    incrrotvect(:,snapshot)=V;
                    incrrotvectmag(:,snapshot)=norm(V)*180/pi;
                    rotvect(:,snapshot)=rotmat2rotvec(R);
                    omegas(:,snapshot)=omega;
                    Omegas(:,snapshot)=R'*omega;
                    L=R*I*R'*omega;
                    momenta(:,snapshot)=L;
                    %                  1/2*omega'*L
                    kinenergy(snapshot)= 1/2*omega'*L;
                    etas(snapshot)=get(ri,'eta');
                    vectup(:,snapshot)=R(:,3);
                    % graphics
                    if graphics
                        currgeom=rotate(geom, R);
                        u=currgeom-geom;
                        gv=reset (gv,struct('limits',limits));
                        draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                        headlight(gv); view(3)
                        pause(0.005); % next eigenvector
                    end
                    if (round(i/(reportat))*reportat == i)
                        disp([num2str(i) ' steps of ' num2str(nsteps)]);
                    end
                end
                %             disp(['Reached time ' num2str(get(ri,'t'))]);
                %             toc

                if (tend == 0.4)
                    Vdiff=rotmat2rotvec(converged_R_at_tend_0_4*R');
                    disp(['Error in rotation vector: ' num2str(norm(Vdiff))]);
                end

                hold on
                npts=size(momenta,2);
                setnum=setnum+1;
                set(gca,'LineWidth',2);
                set(gca,'FontSize',16);
                set(gca,'TickLength',[0.025 0.06]);  % default values are: 0.0100 0.0250
                set(gca,'XGrid','on');
                set(gca,'YGrid','on');
                xlabel('Time');
                plotwhat1=plotwhat{1};
                if (~strcmp(class(plotwhat{1}),'char'))
                    plotwhat1=num2str(plotwhat);
                end
                switch plotwhat1
                    case {'0' 'kin'}
                        ylabel('Kinetic energy');
                        filename=[mfilename(1) '-kin-' num2str(dt)];
                        plot(dt*(0:npts-1), kinenergy(1:npts), [colors(4) line], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), kinenergy(markers), [colors(4) marker_type(setnum)], 'LineWidth', 1.5);
                    case '1'
                        ylabel('Normalized Kinetic energy Error');
                        filename=[mfilename '-normkin-' num2str(dt)];
                        exactkinenergy=kinenergy(1);
                        plot(dt*(0:npts-1), (kinenergy(1:npts)-exactkinenergy)/exactkinenergy, [colors(4) line], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), (kinenergy(markers)-exactkinenergy)/exactkinenergy, [colors(4) marker_type(setnum)], 'LineWidth', 1.5);
                    case '2'
                        ylabel('Angular velocity/body frame');
                        filename=[mfilename '-bfOmega-' num2str(dt)];
                        plot(dt*(0:npts-1), Omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), Omegas(2,1:npts), [colors(2) '--'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), Omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Omegas(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Omegas(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Omegas(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\Omega_1', '\Omega_2', '\Omega_3');
                    case '3'
                        ylabel('Angular velocity/spatial frame');
                        filename=[mfilename '-omega-' num2str(dt)];
                        plot(dt*(0:npts-1), omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), omegas(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), omegas(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), omegas(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\omega_1', '\omega_2', '\omega_3');
                    case {'4' 'mom' 'pi'}
                        ylabel('Spatial angular momenta');
                        filename=[mfilename '-mom-' num2str(dt)];
                        plot(dt*(0:npts-1), momenta(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), momenta(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), momenta(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), momenta(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), momenta(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), momenta(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\pi_1', '\pi_2', '\pi_3');
                    case '5'
                        ylabel('Components of vector-up');
                        filename=[mfilename '-vectup-' num2str(dt)];
                        hold on
                        axis square
                        plot(vectup(1,:), vectup(2,:), ['r.'],  'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(vectup(1,markers), vectup(2,markers), ['b'  marker_type(setnum)],  'LineWidth', 1.5);
                    case '6'
                        ylabel('Incremental rotation vector');
                        filename=[mfilename '-incrrotvec-' num2str(dt)];
                        plot(dt*(0:npts-1), incrrotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), incrrotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), incrrotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), incrrotvect(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), incrrotvect(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), incrrotvect(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\Delta\Theta_1', '\Delta\Theta_2', '\Delta\Theta_3');
                    case '7'
                        ylabel('Magnitude of incremental rotation vector');
                        filename=[mfilename '-incrrotvecmag-' num2str(dt)];
                        plot(dt*(0:npts-1), incrrotvectmag(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), incrrotvectmag(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    case '8'
                        ylabel('Rotation vector');
                        filename=[mfilename '-rotvec-' num2str(dt)];
                        plot(dt*(0:npts-1), rotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), rotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), rotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), rotvect(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), rotvect(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), rotvect(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\Theta_1', '\Theta_2', '\Theta_3');
                    case '14'
                        ylabel('Norm of spatial angular momenta');
                        filename=[mfilename '-nmom-' num2str(dt)];
                        nm=sqrt(momenta(1,:).*momenta(1,:)+momenta(2,:).*momenta(2,:)+momenta(3,:).*momenta(3,:));
                        plot(dt*(0:npts-1), nm, [colors(1) '-'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), nm(markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('||\pi||');
                    case {'Pi'}
                        ylabel('Angular momenta/body frame');
                        filename=[mfilename '-Pi-' num2str(dt)];
                        Pis=Omegas;
                        for i=1:npts
                            Pis(:,i)=I*Omegas(:,i);
                        end
                        plot(dt*(0:npts-1), Pis(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), Pis(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                        plot(dt*(0:npts-1), Pis(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Pis(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Pis(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), Pis(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                        legend('\Pi_1', '\Pi_2', '\Pi_3');
                    case {'eta'}
                        ylabel('\eta');
                        filename=[mfilename(1) '-eta-' num2str(dt)];
                        plot(dt*(0:npts-1), etas(1:npts), [colors(4) line], 'LineWidth', 1.5);
                        nbtwmarkers=round(npts/nmarkers);
                        markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                        nmarkers=nmarkers+2;
                        plot(dt*(markers-1), etas(markers), [colors(4) marker_type(setnum)], 'LineWidth', 1.5);
                    otherwise
                        error('Unknown plot type');
                end
    figure(gcf)
                %pause(2.5);
                disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_100))]);
                nRs=[nRs norm(R-converged_R_at_100)];
                disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_100))]);
                nmbfs=[nmbfs norm(I*Omegas(:,end)-I*converged_Omega_at_100)];
                nmsps=[nmsps norm(momenta(:,end)-exact_spm)];
                anRs.dts=dts;
                anRs.(class(ri))={nRs};
                anmbfs.dts=dts;
                anmbfs.(class(ri))={nmbfs};

            end
            for suffix={'fig' 'png' 'eps2'}
                suf=suffix{1};
                saveas(gcf, [filename '.' suf(1:3)], suf);
            end
            %saveas(gcf, filename, 'png'); % eps2
        end
    end
end