function P=Beam_cross_section(shape)
    switch shape.type
        case 'circle'
            P.A=pi*shape.R^2;
            P.J=pi/2*shape.R^4;
            P.I1=pi/2*shape.R^4;
            P.I2=pi/4*shape.R^4;
            P.I3=pi/4*shape.R^4;
        case 'hollow_circle'
            P.A=pi*(shape.Rext^2-shape.Rint^2);
            P.J=pi/2*(shape.Rext^4-shape.Rint^4);
            P.I2=pi/4*(shape.Rext^4-shape.Rint^4);;%cm^4
            P.I3=pi/4*(shape.Rext^4-shape.Rint^4);;%cm^4
            P.I1=P.I2+P.I3;
            P.J=pi/2*(shape.Rext^4-shape.Rint^4);
        case 'square'
            P.A=shape.a^2;
            P.J=0.1406*shape.a^4;
            P.I1=shape.a^4/6;
            P.I2=shape.a^4/12;
            P.I3=shape.a^4/12;
        case 'rectangle'
            a=max([shape.d2,shape.d3]);
            b=min([shape.d2,shape.d3]);
            c=interp1([1,1.5,2.0, 2.5, 3.0, 4.0, 5.0, 6.0,10,20,40,80,200,2000],...
                [0.141, 0.196, 0.229, 0.249, 0.263, 0.281, 0.291, 0.299, 0.312,0.317, 0.325, 0.33,1/3, 1/3],a/b);
            P.A=shape.d2*shape.d3;
            P.J=c*a*b^3;
            P.I2=shape.d2*shape.d3^3/12;
            P.I3=shape.d2^3*shape.d3/12;
            P.I1=P.I2+P.I3;
        otherwise
            error([' Unknown type: ' char(shape.type)]);
    end
end
