function [node1, node2]= Beam_join(fens,gcells, label1, label2, tolerance)
    l1 =gcell_select(fens,gcells, struct('label',label1));
    m = fenode_to_gcell_map (struct('gcells',subset(gcells, l1)));
    gmap=get (m,'gcell_map');
    endn1=[];
    for i=1:length(gmap)
        if (length(gmap{i})==1)
            endn1= [endn1,i];
        end
    end 
    l2 =gcell_select(fens,gcells, struct('label',label2));
    m = fenode_to_gcell_map (struct('gcells',subset(gcells, l2)));
    gmap=get (m,'gcell_map');
    endn2=[];
    for i=1:length(gmap)
        if (length(gmap{i})==1)
            endn2= [endn2,i];
        end
    end 
    if (length(endn1)~=2)
        error('The beam 1 does not have two ends?');
    end
    if (length(endn2)~=2)
        error('The beam 2 does not have two ends?');
    end
    xyz=get(fens, 'xyz' );
    for i=[1,2]
        if (norm(xyz(endn1(1),:)-xyz(endn2(i),:))<= tolerance)
            node1=endn1(1); node2=endn2(i); 
            return
        end
        if (norm(xyz(endn1(2),:)-xyz(endn2(i),:))<= tolerance)
            node1=endn1(2); node2=endn2(i); 
            return
        end
    end 
    node1=[]; node2=[]; 
end