% Refine a mesh of hexahedrals by octasection.
%
% function [fens,gcells] = refineh8(fens,gcells)
%
function [fens,gcells] = refineh8(fens,gcells)
    [fens,gcells] = H8_to_H27(fens,gcells);
    conn=get(gcells, 'conn');
    nconn=zeros(8*size(conn,1),8);
    nc=1;
    for i= 1:size(conn,1)
        conn27=conn(i,:);
        nconn(nc,:) =conn27([1,9,21,12,17,22,27,25]);        nc= nc+ 1;
        nconn(nc,:) =conn27([9,2,10,21,22,18,23,27]);        nc= nc+ 1;
        nconn(nc,:) =conn27([21,10,3,11,27,23,19,24]);        nc= nc+ 1;
        nconn(nc,:) =conn27([12,21,11,4,25,27,24,20]);        nc= nc+ 1;
        nconn(nc,:) =conn27([17,22,27,25,5,13,26,16]);        nc= nc+ 1;
        nconn(nc,:) =conn27([22,18,23,27,13,6,14,26]);        nc= nc+ 1;
        nconn(nc,:) =conn27([27,23,19,24,26,14,7,15]);        nc= nc+ 1;
        nconn(nc,:) =conn27([25,27,24,20,16,26,15,8]);        nc= nc+ 1;
    end
    gcells=gcellset_H8(struct('conn',nconn));
end
