% Convert a mesh of quadrilateral Q4's to 2 triangles T3 each.
%
% function [fens,gcells] = Q4_to_T3(fens,gcells,options)
%
% options =attributes recognized by the constructor gcell_T3, and
% orientation = 'default' or 'alternate' chooses which diagonal is taken
%      for splitting
% Example: 
% [fens,gcells] = Q4_to_T3(fens,gcells,struct('orientation','alternate'))
% will generate triangles by using the alternate title for splitting.
% 
function [fens,gcells] = H8_to_T4_random(fens,gcells,options)
    t4ia = [8, 4, 7, 5; 6, 7, 2, 5; 3, 4, 2, 7; 1, 2, 4, 5; 7, 4, 2, 5];
    t4ib = [7, 3, 6, 8; 5, 8, 6, 1; 2, 3, 1, 6; 4, 1, 3, 8; 6, 3, 1, 8];
    t4i=t4ia;
    nconns=zeros(5*length(gcells),4);
    w=rand(1,size(nconns,1))> 0.5;
    conns = get (gcells,'conn');
    nc=1;
    for i= 1:length(gcells)
        conn = conns(i,:);
        for j=1:size(t4i,1)
            if (w(nc)) nconns(nc,:) =conn(t4ia(j,:));; else nconns(nc,:) =conn(t4ib(j,:));; end
            nc= nc+ 1;
        end
    end
    options.conn=nconns;
    gcells=gcellset_T4(options);
end
