% Convert a mesh of L2 elements (two-node) to L4 line elements.
%
% function [fens,gcells] = L2_to_L4(fens,gcells,options)
%
% options =attributes recognized by the constructor gcell_L3
function [fens,gcells] = L2_to_L4(fens,gcells,options)
    if ~isstruct(options)
        options = struct('id',1);
    end
    % now generate new node number for each Element
    n=length(fens);
    ng =length(gcells);
    id=get(fens,'id');
    x =get(fens,'xyz');
    id = [id;zeros(2*ng,1)];
    x = [x;zeros(2*ng,size(x,2))];
    conns =zeros(ng,4);
    conns(:,[1,4]) = get (gcells,'conn');
    na=1;
    for i= 1:ng
        id(n+na)=n+na;
        x(n+na,:) =(2*x(conns(i,1),:)+x(conns(i,4),:))/3;
        conns(i,2)= id(n+na);
        na=na+1;
        id(n+na)=n+na;
        x(n+na,:) =(x(conns(i,1),:)+2*x(conns(i,4),:))/3;
        conns(i,3)= id(n+na);
        na=na+1;
    end
    options.id =id;
    options.conn =conns;
    options.other_dimension =get(gcells,'other_dimension');
    gcells=gcellset_L4(options);
    fens=fenodeset(struct('id',id,'xyz',x));
end
