% Make  a cell array of connectivities for use in mesh renumbering routines.
% 
% function conns = gcells_to_conns(gcells)
%     
% conns = cell array of connectivity arrays
function conns = gcells_to_conns(gcells)
    if (iscell(gcells))
        Lc =0;
        for i=1:length(gcells)
            Lc =Lc+get(gcells{i},'nconn');
        end
        conns=cell(Lc,1); % dimension of the matrix
        C=0;
        for i=1:length(gcells)
            conn =get(gcells{i},'conn');
            for j=1:size(conn,1)
                C=C+1;
                conns{C}=conn(j,:);
            end
        end
    else
        Lc =get(gcells,'nconn');
        conns=cell(Lc,1); % dimension of the matrix
        C=0;
        conn =get(gcells,'conn');
        for j=1:size(conn,1)
            C=C+1;
            conns{C}=conn(j,:);
        end
    end
end
